Subject: [rohc] Clarification required in ROHC implementer's guide

From: Kumar Vinod-A20689 <[email-masked]>
Date: Mon, 27 Jun 2005 09:20:10 +0530

Hi,
 
I was going through the draft version of the ROHC implementer's guide and I
noticed the following under section 5.5 (Bit masks in list compression):
 
" It should be noted that even if a list
  has more than 7 items, a 7-bit mask could be used as long as changes
  are only applied in the first part of the reference list, and items
  with an index not covered by the 7-bit mask are thus kept unchanged."
 
I'm not sure how this can be done given the list compression algorithm in
RFC 3095.  Suppose the reference list contains 15 items and I want to remove
the second item.  I will be using the removal only scheme.  According to the
statement above, the bit mask can just be of length 7 bits because the
change has happened in the second item only.  If the compressor sends a
7-bit mask, the decompressor may exhaust the bit mask and still have eight
items unprocessed in the reference list.  What will the decompressor do with
these remaining 8 items?  Can someone please clarify and explain the
decompressor logic when you send a 7-bit mask in the removal only scheme
when the change has occurred in the second item alone and when the reference
list has 15 items?
 
Thanks and Regards,
Vinod
_______________________________________________
Rohc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rohc

---

From: "Lars-Erik Jonsson (LU/EAB)" <[email-masked]>
Date: Mon, 27 Jun 2005 12:25:17 +0200

Vinod,
 
Looking at your question, I can not really see what the problem is. The decompressor takes the reference list as starting point, and then it applies the bit-masks for the insertion/removal schemes, and apply changes when a change is indicated. A bit-mask of 7 bits can simply not make changes to items>7. Why would you do that? Nothing in 3095 says anything about exhausting the bit mask at the decompressor side.
 
So, I still believe what the IG says will work properly, and follows natural from the list compression scheme specification.
 
BR
/L-E

-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of Kumar Vinod-A20689
Sent: den 27 juni 2005 05:50
To: [email-masked]
Subject: [rohc] Clarification required in ROHC implementer's guide

Hi,
 
I was going through the draft version of the ROHC implementer's guide and I noticed the following under section 5.5 (Bit masks in list compression):

I'm not sure how this can be done given the list compression algorithm in RFC 3095.  Suppose the reference list contains 15 items and I want to remove the second item.  I will be using the removal only scheme.  According to the statement above, the bit mask can just be of length 7 bits because the change has happened in the second item only.  If the compressor sends a 7-bit mask, the decompressor may exhaust the bit mask and still have eight items unprocessed in the reference list.  What will the decompressor do with these remaining 8 items?  Can someone please clarify and explain the decompressor logic when you send a 7-bit mask in the removal only scheme when the change has occurred in the second item alone and when the reference list has 15 items?
 
Thanks and Regards,
Vinod

---

From: C Radhakrishna-A12671 <[email-masked]>
Date: Mon, 27 Jun 2005 18:26:07 +0530

Some related questions....
 
1. What is the use of "count" field in "removal only scheme" (RFC3095
Section 5.8.6.3 Encoding Type 2) ?
2. Why it is not there in other schemes (Encoding Types 1 & 3) ?
 
Thanks,
.....RK

-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of
Lars-Erik Jonsson (LU/EAB)
Sent: Monday, June 27, 2005 3:55 PM
To: Kumar Vinod-A20689; [email-masked]
Subject: RE: [rohc] Clarification required in ROHC implementer's guide

Vinod,
 
Looking at your question, I can not really see what the problem is. The
decompressor takes the reference list as starting point, and then it applies
the bit-masks for the insertion/removal schemes, and apply changes when a
change is indicated. A bit-mask of 7 bits can simply not make changes to
items>7. Why would you do that? Nothing in 3095 says anything about
exhausting the bit mask at the decompressor side.
 
So, I still believe what the IG says will work properly, and follows natural
from the list compression scheme specification.
 
BR
/L-E

-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of Kumar
Vinod-A20689
Sent: den 27 juni 2005 05:50
To: [email-masked]
Subject: [rohc] Clarification required in ROHC implementer's guide

Hi,

 
 
Thanks and Regards,
Vinod

---

From: "Lars-Erik Jonsson (LU/EAB)" <[email-masked]>
Date: Mon, 27 Jun 2005 20:32:22 +0200

RK,

To be honest, I really do not know. However, I can guess, and I think this
is just one more of those obscure details of RFC3095. In the removal only
scheme, there was no need for an XI list, and therefore there were 4 bits
left unused. I guess the only reason the Count field was put there was
that there were free bits, and someone thought "let's use them for something".

I do not have a better answer right now, but I guess this means you should
not worry too much about this field. At the compressor, set the value as
stated, but at the decompressor you can ignore it if you want to.

BR
/L-E

-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of C Radhakrishna-A12671
Sent: den 27 juni 2005 14:56
To: [email-masked]
Subject: RE: [rohc] Clarification required in ROHC implementer's guide

1. What is the use of "count" field in "removal only scheme" (RFC3095 Section 5.8.6.3 Encoding Type 2) ?
2. Why it is not there in other schemes (Encoding Types 1 & 3) ?

Thanks,
.....RK
-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of Lars-Erik Jonsson (LU/EAB)
Sent: Monday, June 27, 2005 3:55 PM
To: Kumar Vinod-A20689; [email-masked]
Subject: RE: [rohc] Clarification required in ROHC implementer's guide

Vinod,

BR
/L-E
-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of Kumar Vinod-A20689
Sent: den 27 juni 2005 05:50
To: [email-masked]
Subject: [rohc] Clarification required in ROHC implementer's guide

Hi,

Thanks and Regards,
Vinod

---

From: C Radhakrishna-A12671 <[email-masked]>
Date: Tue, 28 Jun 2005 11:01:02 +0530

L-E,

Thanks for the response.

But, I am not clear on your response to Vinod on insertion/removal bit mask.
My understanding based on RFC3095 (section 5.8.3), insertion/removal bit
mask and its size is derived based on items in curr_list -

(1) For insertion,
    Bit list size = Size of (number of items in) curr_list.
(2) For removal,
    Bit list length = Size of (number of items in) curr_list + number of
items removed.

For example in case of removal scheme, if you have 10 items in ref_list and
4 items
in curr_list which are items 1, 3, 4 & 5 of ref_list, you would send 7-bit
mask of
00100011 (last two bits are set to 1, since the bit list size is 5).
Decompressor
will process till the bit mask is exhausted (as Vinod said) or the ref_list
is
exhausted (whichever happens earlier). So, if you go by only ref_list, you
will
end up in wrong curr_list at the decompressor.

...RK

-----Original Message-----
From: Lars-Erik Jonsson (LU/EAB) [mailto:[email-masked]]
Sent: Tuesday, June 28, 2005 12:02 AM
To: C Radhakrishna-A12671; [email-masked]
Subject: RE: [rohc] Clarification required in ROHC implementer's guide

RK,

that there were free bits, and someone thought "let's use them for
something".

BR
/L-E

-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of C
Radhakrishna-A12671
Sent: den 27 juni 2005 14:56
To: [email-masked]
Subject: RE: [rohc] Clarification required in ROHC implementer's guide

Thanks,
.....RK
-----Original Message-----

Vinod,

BR
/L-E
-----Original Message-----

Hi,

Thanks and Regards,
Vinod